from django.db import models
import os
from django.conf import settings
"""
Database Table that stores the Emails.
"""
def image_path():
    return os.path.join("static/img")

class Email(models.Model):
    """_summary_

    Args:
        models (sender): email address of the sender it has to be a CharField and not an Email Field, 
        because the EmailField does not accept unicode charcters
        models (sender_name): name of sender i.e contact name 
        models (subject): Charfield - subject of the email
        models (content):The actual text of the email - can contain html code
        models (real): Boolean field to define whether the email is to be considered a legitimate one or a phishing email
        models (solution): Textfield - solution text that explains the flaws of the phishing email i.e. wrong links, missspeled email address...
        models (has_attachment): Boolean to determine, if the email has a simulated attachment
        models (attachment): Charfield, that holds the name of the attachment
        models (priority): Boolean field that determines whether the email should be prioritized over others.
    """
  
    sender=models.CharField(blank=False, max_length=255, default="")
    sender_name=models.CharField(blank=False, max_length=100, default="")
    subject=models.CharField(blank=False, max_length=255)
    content= models.TextField(default="")
    real=models.BooleanField(blank=False, default=False)
    solution=models.TextField(blank=False, default="")
    has_attachment=models.BooleanField(blank=False, default=False)
    attachment=models.CharField(max_length=255, default="none")
    priority=models.BooleanField(default=False, blank=False)
#shows these attributes in the admin panel to identify the emails
    def __str__(self):
        return (str(self.id)+", "+self.sender+", "+self.sender_name+", "+self.subject)
