//---------------- Variables ----------------

var blue = "#173B4B"; //Main Color
var blueHover = "#0d232d";

var grey = "#3d3d3d";
var greyHover = "#505050";

var green = "#126758";


//---------------- Show / Hide Object ----------------

function show(id) {
    var container = document.getElementById(id);
    container.classList.remove("hide");
}

function hide(id) {
    var container = document.getElementById(id);

    container.classList.add("hide");
}

//---------------- Link Preview ----------------

function initializeLinkPreview () {
    const linkElements = document.getElementsByClassName("link");

    for (let i = 0; i < linkElements.length; i++) {
        const linkElement = linkElements[i];
        
        linkElement.addEventListener("mouseover", function() {
            const linkContentElement = this.getElementsByClassName("link-content")[0];
            const linkPreview = document.getElementById("link-preview");
            
            linkPreview.textContent = "";
            
            linkPreview.classList.remove("hide");
            
            linkPreview.textContent = linkContentElement.textContent;
        });
        
        linkElement.addEventListener("mouseout", function(event) {
            event.preventDefault();

            const linkPreview = document.getElementById("link-preview");
            
            linkPreview.classList.add("hide");
        });
    }
}

//---------------- Game Logic ----------------

var solutionSate = false;
var score = 0;
var emailTotal;
var emailCurrent = 0;

var scoreElement;
var progressElement;
var gameButtonElement;
var nextButtonElement;

var emailResults;

function initializeGameLogic(thisEmailTotal, thisEmailResults) {
    if (thisEmailTotal >= 5) {
        emailTotal = 5;
    } else {
        emailTotal = thisEmailTotal;
    }

    if (thisEmailTotal >= 1) {
        emailCurrent = 1;
    }

    emailResults = thisEmailResults;

    scoreElement = document.getElementById("score");
    progressElement = document.getElementById("progress");
    gameButtonElement = document.getElementById("game-buttons");
    nextButtonElement = document.getElementById("next-button");

    updateProgress(emailCurrent, emailTotal);

    document.getElementById("email-" + emailCurrent).classList.remove("remove");
}

function updateProgress(left, right) {
    progressElement.textContent = left + "/" + right;
}

function spamButton() {
    var solutionElement = document.getElementById("solution-" + emailCurrent);
    var solutionTextElement = document.getElementById("solution-text-" + emailCurrent);

    solutionElement.classList.remove("remove");

    if(emailResults[emailCurrent - 1] == false) {
        score = score + 1;
        scoreElement.textContent = score;
        
        solutionTextElement.innerHTML = "<strong>Correct! This is a Phishing mail.</strong><br><br>" + solutionTextElement.innerHTML;
    } else {
        solutionTextElement.innerHTML = "<strong>Incorrect! This mail is Real.</strong><br><br>" + solutionTextElement.innerHTML;
    }

    gameButtonElement.classList.add("remove");
    nextButtonElement.classList.remove("remove");
}

function authenticButton() {
    var solutionElement = document.getElementById("solution-" + emailCurrent);
    var solutionTextElement = document.getElementById("solution-text-" + emailCurrent);

    solutionElement.classList.remove("remove");

    if(emailResults[emailCurrent - 1] == true) {
        score = score + 1;
        scoreElement.textContent = score;
        
        solutionTextElement.innerHTML = "<strong>Correct! This mail is Real.</strong><br><br>" + solutionTextElement.innerHTML;
    } else {
        solutionTextElement.innerHTML = "<strong>Incorrect! This is a Phishing mail.</strong><br><br>" + solutionTextElement.innerHTML;
    }

    gameButtonElement.classList.add("remove");
    nextButtonElement.classList.remove("remove");
}

function nextButton() {
    var currentSolutionElement = document.getElementById("solution-" + emailCurrent);
    var currentMailElement = document.getElementById("email-" + emailCurrent);

    nextButtonElement.classList.add("remove");
    currentSolutionElement.classList.add("remove");
    currentMailElement.classList.add("remove");

    if(emailCurrent + 1 <= emailTotal) {   
        emailCurrent = emailCurrent + 1;

        var nextMailElement = document.getElementById("email-" + emailCurrent);
        var nextSolutionElement = document.getElementById("solution-" + emailCurrent);

        gameButtonElement.classList.remove("remove");
        nextMailElement.classList.remove("remove");


        updateProgress(emailCurrent, emailTotal);
    } else {
        var resultElement = document.getElementById("result");
        var resultScoreElement = document.getElementById("resultScore");
        var resultTotalElement = document.getElementById("resultTotal");
        var retryButtonElement = document.getElementById("retry-button");

        resultScoreElement.textContent = score;
        resultTotalElement.textContent = "out of " + emailTotal;

        document.getElementById("score-progress-head").classList.add("remove");
        resultElement.classList.remove("remove");
        retryButtonElement.classList.remove("remove");
    }
}