import random
from django.shortcuts import render
from.models import Email

# get all emails from the database and sort them into normal emails and prioritized emails
def index(request):
    all_emails= Email.objects.all()
    email_list = []
    priority_list = []
    for email in all_emails:
        if email.priority == True:
            priority_list.append(email)
        else:
            email_list.append(email)
                
#   Generate a list of Emails and Phishing Emails pseudo-randomly using the Fisher–Yates shuffle algorithm
    random.shuffle(email_list)
    random.shuffle(priority_list) 
    # if the amount of priority emails is at least 5 (should be the same limit as in the frontend) only those will be used.
    #Otehrwise, the other emails will be used as well but only after the prioritized ones.
    if len(priority_list) >=5:
        context = {"APP_NAME": "PhishCoach"}
        context.update({"emails": priority_list})
    
    else:
        combined_list = priority_list + email_list
        context = {"APP_NAME": "PhishCoach"}
        context.update({"emails": combined_list})
    
    return render(request, "index.html", context)
