# Welcome to PhishCoach

## Platform compatibility
This ReadMe assumed that Windows 10 is used as environment. Different Windows versions should work also, but have not been tested.

If Linux is used the Initialization and Startup Scripts will not work and the manual setup has to be done. As this has not been tested, we assume that some commands from the manual setup will work differently. (Like activating the virtual environment.)


## Automatic Initialization

### Install Python
Install Python, while making sure that the `Path` option is ticked during setup.

### Set the execution policy
Run PowerShell as administrator and run the following command to check if you have permissions to execute shell scripts: `Get-ExecutionPolicy -list`.
If you have no permissions, use the command `Set-ExecutionPolicy RemoteSigned CurrentUser` to change the permissions for your current user. After activating the virtual environment, you can change the permissions back again if you like. But keep in mind that you have to do this procedure every time you want to activate your python virtual environment.

### Initialization Script
To ensure that a working shortcut can be created using this script the folder of PowerShell needs to be at `C:\Windows\System32\WindowsPowerShell\v1.0\powershell.exe`. If this is not the case, the manual setup is necessary.

To initialize the project automatically, right click the `PhishCoach_Initialization.ps1` and click `Run with PowerShell`. This will load a bit, but should work. If it did work the window will close.

This creates an automatic admin account with the username `admin` and the password `123`, with which it is possible to log into the admin panel to create emails.

### Startup Script
The root folder contains a script that automatically starts a PowerShell script that migrates potential changes, starts the server and opens two browser tabs (the admin panel and the PhishCoach webapplication).

The Initialization Script should have automatically created a shortcut to this `PhishCoach_Startup.ps1` file which runs it using PowerShell. This shortcut is called `PhishCoach`

The Shortcut can be moved anywhere and is able to execute PhishCoach with a double click on it.

Make sure that the script is never moved or the script and shortcut will not work correctly.

When running the shortcut, make sure to not close the PowerShell window, as this is the running server.

If the Startup Script Shortcut works, `Manual Shortcut` and `Manual Setup` can be ignored.

### Manual shortcut 
If the creation of the shortcut did not work with the initialization script, the following steps are necessary to create a working shortcut:

- Right click in the explorer folder of the script location

- In the `Target Field` enter (replace `REPLACE_WITH_FOLDER_PATH` with the current folder location): `C:\Windows\System32\WindowsPowerShell\v1.0\powershell.exe -command "& 'REPLACE_WITH_FOLDER_PATH\PhishCoach_Startup.ps1'"`

- In the `Run In` field enter (same folder path as above): `REPLACE_WITH_FOLDER_PATH`

When running the shortcut, make sure to not close the PowerShell window, as this is the running server.


## Manual setup

### Startup
The ♻️ symbol in this manual setup means that it is needed on every startup of the program, the rest is only needed for a first time initialization.

### Run Powershell
♻ In the root folder of the project, while holding shift, right click an empty space and click on `open in PowerShell`.

### Create virtual environment
In CMD or PowerShell `python -m venv .venv`

### Activate virtual environment 
♻️ (CMD) `.venv\Scripts\activate.bat`
♻️ (PowerShell) `& .venv\Scripts\Activate.ps1`
If PowerShell is not working, use the following PowerShell command to check if you have permissions to execute shell scripts: `Get-ExecutionPolicy -list`.
If you have no permissions, use the command `Set-ExecutionPolicy RemoteSigned CurrentUser` to change the permissions for your current user. After activating the virtual environment, you can change the permissions back again if you like. But keep in mind that you have to do this procedure every time you want to activate your python virtual environment.

### Run server
Install Django using the command `pip install Django`.
♻️ To run the server use the following command: `python .\PhishCoach\manage.py runserver`

### Create your own sqlite3 database
Initially, use the command `python .\PhishCoach\manage.py makemigrations PhishCoach` to tell Django that you made changes to the database models and you would like to store them as a migration.
Then, use the command `python .\PhishCoach\manage.py migrate` to execute the migrations and create your database table(s) or apply the changes.

### Create first admin account
To fill the database with emails, you need to have admin access. For this, use the command `python .\PhishCoach\manage.py createsuperuser`. The programm will guide you through the rest.

This step is also necessary if you accidentally deleted all admin users.


## Instructions

### Create additional admin accounts
To create additional admin accounts, log into the admin panel using the account you have already created.

Then click on `Users` and on `Add User`. Then create the desired user.

After creation check the `Staff status` box for this user and click save to give the user admin rights.

It is now possible to log into the admin panel with your new user. You can delete the admin user now.

### Change email
To change an email, log into the admin panel.

Then click on the `Emails` tab and select the email that needs to be changed.

After the changes are done, click save.

### Create email
To create an email, log into the admin panel.

Either click on the `Add` next to the `Emails` tab or click on the `Emails` tab and click `ADD EMAIL`

After inserting the necessary values click save.